
'------------------------------------------------------------------------------
' File:        CDHDCAN.PRG
' Purpose:     Example of CAN configuration for CDHD
' Version:     1.00
' Author:      <MyFullName>
' Description:
' History:     YYYY-MM-DD  <MyShortCut>  V1.00
'              Created
'------------------------------------------------------------------------------

' module global "constants"


' module global variables
dim shared PFAC_TOO_LOW  as error "Position factor too low increase PNUM/PDEN to 4096 at least"

program
  
  dim axcount as long 
  dim try_count as long = 0
  dim axesinuse as long = 1       '<<<<<------------ how many axes are connected                   ---------------
  dim FIRSTADDRESS as long = 1    '<<<<<----------- Here is the address if min node on the network ---------------
  dim axisdaddoffset as const long = (FIRSTADDRESS - 1)  ' address of the first axis  minus 1.
  dim pllLocked as long
  
  bus[CAN_BUSID].ctim=4000
  call can_reset ' reset can controller
' NMT PREOP state  
  bus[CAN_BUSID].phase = 0
  sleep 300 'sleep less than 100 msec produces error in this task!
'----------------------- IS setup -------------------------
  for axcount = 1 to axesinuse 
     AxesList[axcount].dadd =   axisdaddoffset +  axcount  
  '   AxesList[axcount].busnumber = CAN_BUSID
     call Axis_Setup(AxesList[axcount])
     print "Drive ";AxesList[axcount].dadd;" Version ";is_ver(AxesList[axcount].dadd)
  next
  ' CDHD SETUP
'----------------------- CDHD setup -------------------------

'----------------------- CDHD setup -------------------------
' NMT OP mode
  bus[CAN_BUSID].phase = 4
  sleep 100
' set correct operation mode   
  for axcount = 1 to axesinuse 
    call CAN_SDO_WRITE(AxesList[axcount].dadd,0x6060,0,8,8)' intepolation  position mode
    sleep 10
    Print "Drive ";AxesList[axcount].dadd;" Opmode =",CAN_SDO_READ(AxesList[axcount].dadd,0x6061,0) 
  next 
 Print "type: jog a1 100 starttype=1"

end program


sub Axis_Setup(Ax as generic axis)

attach Ax  
Ax.en=0
Ax.pedel=7


call CAN_SDO_WRITE(Ax.dadd , 0x60c2, 1 , 8 , bus[0].ctim/1000) '''Drive cycle time
call CAN_SDO_WRITE(Ax.dadd , 0x60c2, 2 , 8 , -3) '''msecs
CALL  CDHDMapPDO(Ax.dadd) ' map PDOs
sleep 20
Ax.MotionBusVelocityBase=1000 
Ax.MotionBusVelocityScale=0 
Ax.pfac = (can_sdo_read(ax.dadd,0x6092,1)/can_sdo_read(ax.dadd,0x6092,2))*(can_sdo_read(ax.dadd,0x6091,1)/can_sdo_read(ax.dadd,0x6091,2))
if Ax.pfac < 4096 then
  print "Position factor too low increase PNUM/PDEN to 4096 at least"
  throw PFAC_TOO_LOW
end if
Ax.vfac = Ax.pfac / 1000/60 'RPM
Ax.afac = Ax.vfac / 1000 
Ax.jfac = Ax.afac / 1000 
Ax.pemax = 10
Ax.Amax=100000
Ax.dmax=100000
Ax.jmax=1000000
Ax.Acc=100000
Ax.dec=100000
Ax.jerk=1000000
'reset fault
call CAN_SDO_WRITE(Ax.dadd, 0x6040, 0,16, 128)
sleep 20
call CAN_SDO_WRITE(Ax.dadd, 0x6040, 0,16, 0)
Print "Opmode =",CAN_SDO_READ(Ax.dadd,0x6061,0) 
detach Ax

end sub
