'------------------------------------------------------------------------------
' File:        AX_SETUP.PRG
' Purpose:     A general script that sets up all the axes found in the system with the same motion parameters
'              ATTENTION, THIS FILE IS JUST INITIAL EXAMPLE HOW TO SET AXIS PARAMETERS IT IS USED FOR BASIC OPERATION ONLY !!!!!
'              IT IS NOT A COMPLETE AXIS SETUP. FOR COMPLETE AXIS SETUP PLEASE USE MANUALS OR CONSULT SERVOTRONIX REPRESENTATIVE!
' Version:     1.00
' Author:      Nir Geller
' Global Variables Used: num_Of_Motion_Drives as long  - Number of ECat Motion Drives found by EC_SETUP.PRG
'						 Axes[64] - An array that holds all the axes in the system. Defined in CONFIG.PRG
' Description:
' History:		6.11.13		-	Created
'				19.Aug.2014	-	added: Vlim, PEmax
'							-	modified - homing velocities and acceleration are in user units
'----------------------------------------------------------------------------------------------------------------


Program

	dim i as long = 1
'	dim dHomingFactorFast	as double = 0.5
'	dim dHomingFactorslow	as double = 0.25
'	dim dHomingFactorAcc	as double = 0.1
'	dim dSec2msec			as double = 1000	'	this is used to convert from typical user time-units [msec] to typical drive time-units [sec]
'	dim dHomingVelocity		as double
'	dim dHomingAcceleration	as double
'	dim dVelocityLimit		as double
'	dim dDrivePeMax			as double
	dim genAxis	as generic axis

	for i = 1 to num_Of_Motion_Drives
		genAxis = systemAxis(i)
		with genAxis
			Attach 
				' **** Set Motion Parameters ****
				Pedel = 5.07  '  CDHD with ethercat requires 5.07 cycles
				Fmode = 0
				PeMax = 1
				MotionBusVelocityScale = 0
				MotionBusVelocityBase = 1000 ' counts per sec matches CDHD
				Pfac = Pos_Units[Dadd]/360		'	deg
				Vfac = Pfac/1000				'	deg/sec
				Afac = Vfac/1000				'	deg/sec^2
				Jfac = Afac/1000				'	deg/sec^3
				Vmax = 720.0					'	2 r/sec
				Vcruise = Vmax / 2				'	1 r/sec
				Vospd = Vmax * 1.2
				VelocitySafetyLimit = Vmax * 10.0
				Amax = Vmax * 10.0
				Dmax = Amax
				Jmax = Amax * 10.0
				Acc = Amax
				Dec = Amax
				Jerk = Jmax
			Detach
		end with
	next


'	for i = 1 to num_Of_Motion_Drives
'
'		attach Axes[i]
'
'			' **** Set Motion Parameters ****
'			Axes[i].PeDel = 5	'	CDHD with ethercat requires 5 cycles
'			Axes[i].fmode = 0
'			Axes[i].pemax = 0.1
'			Axes[i].pfac = Pos_Units[Axes[i].dadd]
'			Axes[i].MotionBusVelocityScale = 0
'			Axes[i].MotionBusVelocityBase = 1000 ' counts per sec matches CDHD
'			Axes[i].vfac = Axes[i].pfac/1000/60
'			Axes[i].afac = Axes[i].vfac/1000
'			Axes[i].jfac = Axes[i].afac/1000
'			Axes[i].VCruise = 60	'	=  single_cycle/second
'			'---------------------
'			Axes[i].vmax = 3000
'			Axes[i].vospd = Axes[i].vmax * 1.2
'			Axes[i].velocitysafetylimit = Axes[i].vmax * 10
'			'----------------------------------
'			Axes[i].amax = 30000
'			Axes[i].dmax = 30000
'			Axes[i].jmax = 300000
'
'			Axes[i].acc = 2000
'			Axes[i].dec = 2000
'			Axes[i].jerk = 20000
'
'
'			' **** Set homing parameters ****
'			' set homing method = 34 (pulse index, positive direction)
'			call EC_SLAVE_SET_HOMING_PARAMETERS(Axes[i], HOMING_METHOD, 34)
'
'			' set homing offset
'			call EC_SLAVE_SET_HOMING_PARAMETERS(Axes[i], HOMING_OFFSET, 0)
'
'			' set FAST homing speed = 10
'			dHomingVelocity = (Axes[i].VCruise * Axes[i].VFac * dSec2msec) * dHomingFactorFast
'			call EC_SLAVE_SET_HOMING_PARAMETERS(Axes[i], FAST_HOMING_SPEED, dHomingVelocity)
'
'			' set SLOW homing speed = 2
'			dHomingVelocity = (Axes[i].VCruise * Axes[i].VFac * dSec2msec) * dHomingFactorSlow
'			call EC_SLAVE_SET_HOMING_PARAMETERS(Axes[i], SLOW_HOMING_SPEED, dHomingVelocity)
'
'			' set homing acceleration/deceleration
'			dHomingAcceleration = (Axes[i].amax * Axes[i].afac * dSec2msec^2) * dHomingFactorAcc
'			call EC_SLAVE_SET_HOMING_PARAMETERS(Axes[i], HOMING_ACCELERATION, dHomingAcceleration)
'
'			' Display Homing Parameter on terminal
'			'get homing method
'			print "Axis no. ";i;" Homing method is ";EC_SLAVE_GET_HOMING_PARAMETERS(Axes[i], HOMING_METHOD)
'
'			'get homing offset
'			print "Axis no. ";i;" Homing offset is ";EC_SLAVE_GET_HOMING_PARAMETERS(Axes[i], HOMING_OFFSET)
'
'			'get FAST homing speed
'			print "Axis no. ";i;" Fast Homing speed is ";EC_SLAVE_GET_HOMING_PARAMETERS(Axes[i], FAST_HOMING_SPEED)
'
'			'get SLOW homing speed
'			print "Axis no. ";i;" Slow Homing speed is ";EC_SLAVE_GET_HOMING_PARAMETERS(Axes[i], SLOW_HOMING_SPEED)
'
'			'get homing acceleration/deceleration
'			print "Axis no. ";i;" Homing acceleration/deceleration is ";EC_SLAVE_GET_HOMING_PARAMETERS(Axes[i], HOMING_ACCELERATION)
'
'			'	set axis velocity limit
'			dVelocityLimit = Axes[i].Vmax * Axes[i].Vfac * dSec2msec	'	[rounds/sec]
'			call	EC_SLAVE_SET_VLIM(axes[i], dVelocityLimit)
'
'			'	get velocity limit
'			Print "Axis no. "	;	i	;	" velocity limit is "	;	EC_SLAVE_GET_VLIM(axes[i])
'
'			'	set drive PEmax
'			dDrivePeMax = axes[i].PeMax * axes[i].Pfac	'	[counts]
'			call EC_SLAVE_SET_PE_MAX(axes[i], dDrivePeMax)
'
'			'	get drive PEmax
'			Print "Axis no. "	;	i	;	" PEmax is "	;	EC_SLAVE_GET_PE_MAX(axes[i])
'
'		detach Axes[i]
'
'	next

	Print "Done setting motion and homing parameters to all the axes"

end program

