'------------------------------------------------------------------------------
' File:        profvel.prg
' Purpose:     Example of operation of profile velocity mode over PDO
'              cdhd opmode 3 (0x6060.0), velocity is written via PDO object 0x60ff.0
' Version:     1.00
' Author:      <MyFullName>
' Description:
' History:     YYYY-MM-DD  <MyShortCut>  V1.00
'              Created
'------------------------------------------------------------------------------

' module global "constants"


' module global variables

dim shared profvel[2000] as long
dim shared accel as long
dim shared deccel as long
dim shared velcruise as long = 360*a1.vfac*1000 ' 1 rps
dim shared velindex as long =0
program
dim i as long
dim vel as long
attach a1
a1.en=0
while a1.en
sleep 10
end while
a1.opmode = 1 ' velocity mode 
a1.PEMax = 1e100 ' no pe checking
call ec_pdo_write(a1.dadd,0x60ff,0,0) 'stop - write 0 to velocity object
call ec_pdo_write(a1.dadd,0x6060,0,3) ' profile vel mode
sleep 20
a1.en=1
' 500 -point - acc
accel = velcruise/500
' 200 -points - dec
deccel = velcruise/200
' calculate profile
vel = 0
' 500 point acceleration
for i = 1 to 500
profvel[i] = vel 
vel = vel + accel
next 
' 1300 points cruise vel
for i = 500 to 2000-200
profvel[i] = vel 
next 
' last 200 point deceleration
for i = 2000-200 to 2000
profvel[i] = vel 
vel = vel - deccel
next 
velindex = 1
' event that sends contents of array to the drive via Profile Velocity PDO
onevent profile
  call ec_pdo_write(a1.dadd,0x60ff,0,profvel[velindex]) 'stop
  velindex = velindex + 1
  if velindex >= 2000 then
    velindex = 1
  end if  
end onevent
eventon profile

while 1
sleep 100
end while

end program ' <MyTask>.prg
