'************************  AXL_AI_8_ME IO Module Library  ************************
'
' This program demonstrates how to read the analog inputs of the IO module as raw data
' and as voltage.
'*********************************************************************************


program

	dim module_address as long = 5   '   Set according to system's topology !!
	dim tempVal as long = 0
	dim Raw_Data[8] as long
	dim Voltage[8] as double
	dim t0 as long = 0
	dim i as long = 0

	?AI8ME_Set_Measuring_range(module_address, 8, 1)

	while 1

		' Read An-In via SDO
		call AI8ME_SDO_Ananlog_Inputs_Raw(module_address, Raw_Data)
		for i = 1 to 8
			printu "Raw Data[#]: #";i, Raw_Data[i]
		next

		t0 = sys.clock
		call AI8ME_SDO_Ananlog_Inputs_Double(module_address, Voltage)
		printu "Read time # milliseconds";sys.clock - t0

		for i = 1 to 8
			printu "Voltage[#]: ##.####";i, Voltage[i]
		next

		print ""

		sleep 2000



		' Read An-In via PDO
		call AI8ME_PDO_Ananlog_Inputs_Raw(module_address, Raw_Data)
		for i = 1 to 8
			printu "Raw Data[#]: #";i, Raw_Data[i]
		next

		t0 = sys.clock
		call AI8ME_PDO_Ananlog_Inputs_Double(module_address, Voltage)
		printu "Read time # milliseconds";sys.clock - t0

		for i = 1 to 8
			printu "Voltage[#]: ##.####";i, Voltage[i]
		next

		print ""

		sleep 2000
		
	end while

end program


