'************************  FastData over Shared Memory Program Example  ************************
'
' File:    FASTDATA.PRG
' Purpose:  This is an example of use of the FastData over shared memory module.
'			The interface is supplied in FASTDATA.LIB
'
' Version:  1.0.0.0
' Author:  Nir Geller
'
' History:  18.7.2016  V1.0.0.0 - Created
'
' ********************************************************************************

common shared shm_long_in[8] as long
common shared shm_long_out[8] as long
common shared shm_dbl_in[8] as double
common shared shm_dbl_out[8] as double


Program

	dim retVal as long = 0
	dim i as long = 0


	for i = 1 to 8
		shm_long_out[i] = i
		shm_dbl_out[i] = i/10
	next


	while 1

		retVal = FastData_Read_Long(shm_long_in[1], 1)
		if retVal <> 0 then
			print "FastData_Read_Long failed..."
		end if
		retVal = FastData_Read_Long(shm_long_in[2], 3)
		if retVal <> 0 then
			print "FastData_Read_Long failed..."
		end if
		retVal = FastData_Read_Long(shm_long_in[3], 7)
		if retVal <> 0 then
			print "FastData_Read_Long failed..."
		end if
		retVal = FastData_Read_Long(shm_long_in[4], 15)
		if retVal <> 0 then
			print "FastData_Read_Long failed..."
		end if


		retVal = FastData_Write_Long(shm_long_out[1], 1)
		if retVal <> 0 then
			print "FastData_Write_Long failed..."
		end if
		retVal = FastData_Write_Long(shm_long_out[2], 2)
		if retVal <> 0 then
			print "FastData_Write_Long failed..."
		end if

		retVal = FastData_Write_Long(shm_long_out[3], 7)
		if retVal <> 0 then
			print "FastData_Write_Long failed..."
		end if

		retVal = FastData_Write_Long(shm_long_out[4], 13)
		if retVal <> 0 then
			print "FastData_Write_Long failed..."
		end if

		retVal = FastData_Write_Long(shm_long_out[7], 17)
		if retVal <> 0 then
			print "FastData_Write_Long failed..."
		end if


		retVal = FastData_Read_Double(shm_dbl_in[1], 1)
		if retVal <> 0 then
			print "FastData_Read_Double failed..."
		end if
		retVal = FastData_Read_Double(shm_dbl_in[2], 3)
		if retVal <> 0 then
			print "FastData_Read_Double failed..."
		end if
		retVal = FastData_Read_Double(shm_dbl_in[3], 7)
		if retVal <> 0 then
			print "FastData_Read_Double failed..."
		end if
		retVal = FastData_Read_Double(shm_dbl_in[4], 12)
		if retVal <> 0 then
			print "FastData_Read_Double failed..."
		end if



		retVal = FastData_Write_Double(shm_dbl_out[1], 1)
		if retVal <> 0 then
			print "FastData_Write_Double failed..."
		end if

		retVal = FastData_Write_Double(shm_dbl_out[2], 2)
		if retVal <> 0 then
			print "FastData_Write_Double failed..."
		end if

		retVal = FastData_Write_Double(shm_dbl_out[3], 10)
		if retVal <> 0 then
			print "FastData_Write_Double failed..."
		end if

		retVal = FastData_Write_Double(shm_dbl_out[4], 14)
		if retVal <> 0 then
			print "FastData_Write_Double failed..."
		end if
		
		retVal = FastData_Write_Double(shm_dbl_out[7], 19)
		if retVal <> 0 then
			print "FastData_Write_Double failed..."
		end if

		for i = 1 to 8
			shm_long_out[i] = shm_long_out[i] + 1
			shm_dbl_out[i] = shm_dbl_out[i] + 0.1
		next

		sleep 1000

	end while

End Program


