'**********************************************************************************************************
' File:			Move.PRG
' Purpose:		Move two axes in Position Mode
' Version:		1.00
' Author:		Nir Geller
' Description:	This is an example of a simple MOVE command. The axes are set to 'Position Mode'.
'				The cruise velocity is passed as a nodal value.
'				The command is absolute (abs = 1).
'**********************************************************************************************************


program

	attach a3
	attach a5

	call EC_SET_MOTION_OPMODE(a3, POSITIONMODE)
	call EC_SET_MOTION_OPMODE(a5, POSITIONMODE)

	a3.en=1
	a5.en=1
	
	sleep 1000
	
	while 1
	
		MOVE a3 25 vcruise=100 starttype=immediate abs = 1
		MOVE a5 -25 vcruise=100 starttype=immediate abs = 1

		while a3.IsMoving <> 0
			sleep 1000
		end while

		while a5.IsMoving <> 0
			sleep 1000
		end while

		MOVE a3 0 vcruise=100 starttype=immediate abs = 1
		MOVE a5 0 vcruise=100 starttype=immediate abs = 1
		
		while a3.IsMoving <> 0
			sleep 1000
		end while

		while a5.IsMoving <> 0
			sleep 1000
		end while
		
	end while

	detach a3
	detach a5
	
end program
