'**********************************************************************************************************
' File:			Torque.PRG
' Purpose:		Issue a TORQUE command to two axes in Torque Mode
' Version:		1.00
' Author:		Nir Geller
' Description:	This is an example of a simple TORQUE command. The axes are set to 'Torque Mode'.
'				The command is absolute (abs = 1).
'**********************************************************************************************************

program

	attach a3
	attach a5

	call EC_SET_MOTION_OPMODE(a3, TORQUEMODE)
	call EC_SET_MOTION_OPMODE(a5, TORQUEMODE)

	a3.en=1
	a5.en=1
	
	sleep 1000
	
	while 1

		TORQUE a3 40 starttype=immediate abs = 1
		TORQUE a5 -40 starttype=immediate abs = 1
		
		sleep 3000

		TORQUE a3 0 starttype=immediate abs = 1
		TORQUE a5 0 starttype=immediate abs = 1
		
		sleep 3000
		
	end while

	detach a3
	detach a5
	
end program
