'------------------------------------------------------------------------------
' File:        <MyTask>.prg
' Purpose:     Just an example of a module header
' Version:     1.00
' Author:      <MyFullName>
' Description:
' History:     YYYY-MM-DD  <MyShortCut>  V1.00
'              Created
'------------------------------------------------------------------------------

' module global "constants"


' module global variables


program
a4.en=0
GXYZ.En = 0
call axessetup
attach a4
attach GXYZ
GXYZ.PEMax = 0.1
GXYZ.Abs = 1 ' absolute movement
a4.En = 1' enable axis
GXYZ.En = 1 ' enable axes in group
while 1
  move a4 10 vcruise=1000 abs=0 ' move 10 turns in positive direction
  delay a4 100 ' wait till the end of the movement and dwell 100 msecs
  move a4 -10 vcruise=2000 acc=10000 dec=10000 abs=0 ' move 10 turns in negative direction
  delay a4 100 ' wait till the end of the movement and dwell 50 msecs
' move XYZ group (a1,a2,a3)  
  move GXYZ {10,20,30}
  move GXYZ {0,0,0}
   
end while

end program ' <MyTask>.prg
'------------------------------------------------------------------------------
' File:        AX_SETUP.PRG
' Purpose:     A general script that sets up all the axes found in the system with the same motion parameters
' Version:     1.00
' Author:      Nir Geller
' Global Variables Used: numOfSlaves as long  - Number of ECat drives found by EC_SETUP.PRG
'             AxesList[64] - An array that holds all the axes in the system. Defined in CONFIG.PRG
' Description:
' History:     6.11.13
'              Created
'------------------------------------------------------------------------------
sub axessetup
  dim  i as long   
  for i = 1 to sys.NumberAxes 
  
    attach AxesList[i]
    
      ' **** Set Motion Parameters ****
      AxesList[i].simulated =1 ' simulated axes
      AxesList[i].fmode = 0
      AxesList[i].pemax = 10
      AxesList[i].pfac = mencres ' user units is revolotions and 1 motor revolution is 4096 counts
      AxesList[i].MotionBusVelocityScale = 0
      AxesList[i].MotionBusVelocityBase = 1000 ' counts per sec matches CDHD
      AxesList[i].vfac = AxesList[i].pfac/1000/60 ' speed is rpm
      AxesList[i].afac = AxesList[i].vfac/1000
      AxesList[i].jfac = AxesList[i].afac/1000
      AxesList[i].VCruise = 20
      '---------------------
      AxesList[i].vmax = 3000
      AxesList[i].vospd = AxesList[i].vmax * 1.2
      AxesList[i].velocitysafetylimit = AxesList[i].vmax * 1.5
      '----------------------------------
      AxesList[i].amax = 30000
      AxesList[i].dmax = 30000
      AxesList[i].jmax = 300000

      AxesList[i].acc = 2000
      AxesList[i].dec = 2000
      AxesList[i].jerk = 20000
      
      detach AxesList[i]
    
  next

  print "Done setting motion parameters to all the axes"
  
End sub
